diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
index da00230c5..355fcb8b5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
@@ -63,7 +63,7 @@ public class WorldTypeFXNether extends WorldTypeFX {
                 double rz = (player.z - radius) + (world.rand.nextDouble() * radius * 2);
 
                 if (world.getBlockType(tilePos.set(MathHelper.floor(rx), MathHelper.floor(ry), MathHelper.floor(rz))) == Blocks.AIR) {
-                    world.spawnParticle("ashmote", rx, ry, rz, 0, 0, 0, 0, false);
+                    world.spawnParticle("ashmote", rx, ry, rz, 0, -world.rand.nextDouble() * 0.35D, 0, 0, false);
                 }
             }
         }
@@ -84,7 +84,7 @@ public class WorldTypeFXNether extends WorldTypeFX {
                 double ry = player.y - (double) radius + world.rand.nextDouble() * (double) radius * 2.0F;
                 double rz = player.z - (double) radius + world.rand.nextDouble() * (double) radius * 2.0F;
                 if (world.getBlockType(tilePos.set(MathHelper.floor(rx), MathHelper.floor(ry), MathHelper.floor(rz))) == Blocks.AIR) {
-                    world.spawnParticle("ashmote", rx, ry, rz, 0.0F, 0.0F, 0.0F, 0, false);
+                    world.spawnParticle("ashmote", rx, ry, rz, 0.0F, -world.rand.nextDouble() * 0.35D, 0.0F, 0, false);
                 }
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java b/game/client/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
index 019e7433e..01c89eac6 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
@@ -7,6 +7,7 @@ import com.google.gson.JsonElement;
 import com.google.gson.JsonObject;
 import com.google.gson.JsonParseException;
 import com.google.gson.JsonParser;
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.core.data.registry.Registry;
 import net.minecraft.core.lang.I18n;
@@ -136,19 +137,23 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
                     }
 
                     for (JsonElement element : sounds) {
-                        if (element.isJsonPrimitive()) {
-                            try {
-                                soundEvent.addSoundEntry(getSoundEntry(soundEvent, pack, element.getAsString()));
-                            } catch (RuntimeException ex) {
-                                throwableList.add(ex);
+                        SoundEntry entry = null;
+                        try {
+                            if (element.isJsonPrimitive()) {
+                                entry = getSoundEntry(soundEvent, pack, element.getAsString());
+                            } else if (element.isJsonObject()) {
+                                entry = getSoundEntry(soundEvent, pack, element.getAsJsonObject());
                             }
-                        } else if (element.isJsonObject()) {
-                            try {
-                                soundEvent.addSoundEntry(getSoundEntry(soundEvent, pack, element.getAsJsonObject()));
-                            } catch (RuntimeException ex) {
-                                throwableList.add(ex);
+                            if (entry != null) {
+                                soundEvent.addSoundEntry(entry);
+                                if (entry.preload) {
+                                    Minecraft.getMinecraft().sndManager.preload(entry);
+                                }
                             }
+                        } catch (RuntimeException ex) {
+                            throwableList.add(ex);
                         }
+
                     }
                 }
             }
@@ -169,6 +174,7 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
                 1,
                 16,
                 false,
+                false,
                 SoundEntry.Type.FILE
             );
     }
@@ -211,10 +217,10 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
             attenuation_distance = jObj.get("attenuation_distance").getAsInt();
         }
 
-//        boolean preload = false;
-//        if (jObj.has("preload")) {
-//            preload = jObj.get("preload").getAsBoolean();
-//        }
+        boolean preload = false;
+        if (jObj.has("preload")) {
+            preload = jObj.get("preload").getAsBoolean();
+        }
 
         String type = "file";
         if (jObj.has("type")) {
@@ -233,6 +239,7 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
                 weight,
                 attenuation_distance,
                 stream,
+                preload,
                 SoundEntry.Type.valueOf(type.toUpperCase(Locale.ROOT)
                 ));
     }
diff --git a/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java b/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
index 0ae61e2e2..03925b384 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
@@ -279,6 +279,34 @@ public class SoundEngine
 		return eligible.get(random.nextInt(eligible.size()));
 	}
 
+	public void preload(final String name) {
+		final SoundEvent event = SoundRepository.SOUNDS.getSoundEvent(name);
+		if (event == null) return;
+		for (SoundEntry e : event.getEntryBag().getEntries()) {
+			preload(e);
+		}
+	}
+
+
+	public void preload(final SoundEntry entry) {
+		try {
+			lock.lock();
+			if (!isLoaded()) return;
+			if (entry.type == SoundEntry.Type.EVENT) {
+				preload(entry.name);
+			} else if (entry.type == SoundEntry.Type.FILE && !entry.shouldStream) {
+				final URL url = entry.getURL();
+				if (url != null) {
+					soundSystem.loadSound(url, entry.name);
+				}
+			}
+		} catch (Exception e) {
+			LOGGER.error("Unexpected exception while preloading sound event '{}'!", entry.name, e);
+		} finally {
+			lock.unlock();
+		}
+	}
+
 	public void playSound(final String name, final SoundCategory category, final float volume, final float pitch) {
 		playSound(SoundRepository.SOUNDS.getSoundEntry(name), category, volume, pitch);
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/sound/SoundEntry.java b/game/client/src/main/java/net/minecraft/client/sound/SoundEntry.java
index 7a175cf74..02b048933 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/SoundEntry.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/SoundEntry.java
@@ -42,6 +42,11 @@ public class SoundEntry {
      */
     public final boolean shouldStream;
 
+    /**
+     *  Whether the audio should be preloaded or not
+     */
+    public final boolean preload;
+
     /**
      * How name field is interpreted
      */
@@ -60,6 +65,7 @@ public class SoundEntry {
         int weight,
         int attenuationDistance,
         boolean shouldStream,
+        boolean preload,
         @NotNull Type type
     )
     {
@@ -73,20 +79,21 @@ public class SoundEntry {
         this.weight = weight;
         this.attenuationDistance = attenuationDistance;
         this.shouldStream = shouldStream;
+        this.preload = preload;
         this.type = type;
         if (type == Type.FILE) {
-            file = new File(parentEvent.parentRepo.rootFile, name);
+            this.file = new File(parentEvent.parentRepo.rootFile, name);
         } else {
-            file = null;
+            this.file = null;
         }
     }
 
     public @Nullable URL getURL() {
-        if (file == null || !file.exists()) return null;
+        if (this.file == null || !this.file.exists()) return null;
         try {
-            return file.toURI().toURL();
+            return this.file.toURI().toURL();
         } catch (MalformedURLException e) {
-            System.err.println("Error getting url for sound '" + name + "'");
+            System.err.println("Error getting url for sound '" + this.name + "'");
             e.printStackTrace();
             return null;
         }
@@ -95,10 +102,10 @@ public class SoundEntry {
     @Override
     public String toString() {
         return "SoundEntry{" +
-            "file=" + file +
-            ", name='" + name + '\'' +
-            ", pack=" + pack +
-            ", shouldStream=" + shouldStream +
+            "file=" + this.file +
+            ", name='" + this.name + '\'' +
+            ", pack=" + this.pack +
+            ", shouldStream=" + this.shouldStream +
             '}';
     }
 
@@ -110,6 +117,6 @@ public class SoundEntry {
         /**
          * Name interpreted as a link to a different Event pool
          */
-        EVENT;
+        EVENT
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index e46945dd1..05e590e5b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -353,6 +353,88 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
         return v.x() >= bounds.minX() && v.x() <= bounds.maxX() && v.y() >= bounds.minY() && v.y() <= bounds.maxY();
     }
 
+    protected @Nullable HitResult traceRayAgainstLocalAABB(@NotNull TilePosc tilePos, @NotNull Vector3dc start, @NotNull Vector3dc end, @NotNull AABBdc bounds) {
+        double px = tilePos.x();
+        double py = tilePos.y();
+        double pz = tilePos.z();
+        Vector3d startInBlock = start.add(-px, -py, -pz, new Vector3d());
+        Vector3d endInBlock = end.add(-px, -py, -pz, new Vector3d());
+
+        @Nullable Vector3d minVX = MathHelper.vecClipX(startInBlock, endInBlock, bounds.minX(), new Vector3d());
+        @Nullable Vector3d maxVX = MathHelper.vecClipX(startInBlock, endInBlock, bounds.maxX(), new Vector3d());
+        @Nullable Vector3d minVY = MathHelper.vecClipY(startInBlock, endInBlock, bounds.minY(), new Vector3d());
+        @Nullable Vector3d maxVY = MathHelper.vecClipY(startInBlock, endInBlock, bounds.maxY(), new Vector3d());
+        @Nullable Vector3d minVZ = MathHelper.vecClipZ(startInBlock, endInBlock, bounds.minZ(), new Vector3d());
+        @Nullable Vector3d maxVZ = MathHelper.vecClipZ(startInBlock, endInBlock, bounds.maxZ(), new Vector3d());
+
+        if (!isVecInsideYZBounds(bounds, minVX)) minVX = null;
+        if (!isVecInsideYZBounds(bounds, maxVX)) maxVX = null;
+        if (!isVecInsideXZBounds(bounds, minVY)) minVY = null;
+        if (!isVecInsideXZBounds(bounds, maxVY)) maxVY = null;
+        if (!isVecInsideXYBounds(bounds, minVZ)) minVZ = null;
+        if (!isVecInsideXYBounds(bounds, maxVZ)) maxVZ = null;
+
+        @Nullable Vector3d clip = null;
+        @Nullable Side side = null;
+        double bestD2 = Double.POSITIVE_INFINITY;
+
+        if (minVX != null) {
+            double d2 = startInBlock.distanceSquared(minVX);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = minVX;
+                side = Side.WEST;
+            }
+        }
+        if (maxVX != null) {
+            double d2 = startInBlock.distanceSquared(maxVX);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = maxVX;
+                side = Side.EAST;
+            }
+        }
+        if (minVY != null) {
+            double d2 = startInBlock.distanceSquared(minVY);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = minVY;
+                side = Side.BOTTOM;
+            }
+        }
+        if (maxVY != null) {
+            double d2 = startInBlock.distanceSquared(maxVY);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = maxVY;
+                side = Side.TOP;
+            }
+        }
+        if (minVZ != null) {
+            double d2 = startInBlock.distanceSquared(minVZ);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = minVZ;
+                side = Side.NORTH;
+            }
+        }
+        if (maxVZ != null) {
+            double d2 = startInBlock.distanceSquared(maxVZ);
+            if (d2 < bestD2) {
+                //leave for consistency, if ordering or anything else changes here
+                bestD2 = d2;
+                clip = maxVZ;
+                side = Side.SOUTH;
+            }
+        }
+
+        if (clip == null) {
+            return null;
+        }
+
+        return new HitResult.Tile(tilePos, side, clip.add(px, py, pz, new Vector3d()));
+    }
+
     @Override
     public void onDestroyedByExplosion(final @NotNull World world, final @NotNull TilePosc tilePos) { }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index 53b5267a0..7571fabb6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -6,12 +6,12 @@ import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
-import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.item.block.ItemBlock;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.BoundingVolume;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.WorldSource;
@@ -21,8 +21,12 @@ import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.weather.IPrecipitation;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
+import java.util.ArrayList;
+import java.util.List;
 import java.util.Objects;
 import java.util.Random;
 
@@ -35,8 +39,10 @@ public class BlockLogicFire
     public static final int BURN_INSTANT = 100;
     public static final int BURN_EASY = 60;
     public static final int BURN_MEDIUM = 20;
-    public static final int BURN_HARD = 5;
+    public static final int BURN_HARD = 10;
     public static final int BURN_NEVER = 0;
+    private static final float ASH_LAYER_CHANCE = 0.50F;
+    private static final int ASH_GROUND_SCAN_RANGE = 16;
     private static final int @NotNull [] flameChance = new int[Blocks.blocksList.length];
     private static final int @NotNull [] burnChance = new int[Blocks.blocksList.length];
 
@@ -60,14 +66,14 @@ public class BlockLogicFire
         setFlammable(Blocks.SLAB_PLANKS_OAK, FLAME_HARD, BURN_MEDIUM);
         setFlammable(Blocks.SLAB_PLANKS_PAINTED, FLAME_HARD, BURN_MEDIUM);
         setFlammable(Blocks.STAIRS_PLANKS_OAK, FLAME_HARD, BURN_MEDIUM);
-        setFlammable(Blocks.LOG_OAK, FLAME_HARD, BURN_HARD);
-        setFlammable(Blocks.LOG_PINE, FLAME_HARD, BURN_HARD);
-        setFlammable(Blocks.LOG_BIRCH, FLAME_HARD, BURN_HARD);
-        setFlammable(Blocks.LOG_CHERRY, FLAME_HARD, BURN_HARD);
-        setFlammable(Blocks.LOG_OAK_MOSSY, FLAME_HARD, BURN_HARD);
-        setFlammable(Blocks.LOG_EUCALYPTUS, FLAME_HARD, BURN_HARD);
-        setFlammable(Blocks.LOG_THORN, FLAME_HARD, BURN_HARD);
-        setFlammable(Blocks.LOG_PALM, FLAME_HARD, BURN_HARD);
+        setFlammable(Blocks.LOG_OAK, FLAME_MEDIUM, BURN_HARD);
+        setFlammable(Blocks.LOG_PINE, FLAME_MEDIUM, BURN_HARD);
+        setFlammable(Blocks.LOG_BIRCH, FLAME_MEDIUM, BURN_HARD);
+        setFlammable(Blocks.LOG_CHERRY, FLAME_MEDIUM, BURN_HARD);
+        setFlammable(Blocks.LOG_OAK_MOSSY, FLAME_MEDIUM, BURN_HARD);
+        setFlammable(Blocks.LOG_EUCALYPTUS, FLAME_MEDIUM, BURN_HARD);
+        setFlammable(Blocks.LOG_THORN, FLAME_MEDIUM, BURN_HARD);
+        setFlammable(Blocks.LOG_PALM, FLAME_MEDIUM, BURN_HARD);
         setFlammable(Blocks.LEAVES_OAK, FLAME_EASY, BURN_EASY);
         setFlammable(Blocks.LEAVES_PINE, FLAME_EASY, BURN_EASY);
         setFlammable(Blocks.LEAVES_BIRCH, FLAME_EASY, BURN_EASY);
@@ -98,6 +104,85 @@ public class BlockLogicFire
         return null;
     }
 
+    private static final double PANEL_THICKNESS = 1.0 / 16.0;
+    private static final @NotNull AABBdc SHAPE_PART_GROUND = new AABBd(0.0, 0.0, 0.0, 1.0, 1.0, 1.0);
+    private static final @NotNull AABBdc SHAPE_PART_WEST = new AABBd(0.0, 0.0, 0.0, PANEL_THICKNESS, 1.0, 1.0);
+    private static final @NotNull AABBdc SHAPE_PART_EAST = new AABBd(1.0 - PANEL_THICKNESS, 0.0, 0.0, 1.0, 1.0, 1.0);
+    private static final @NotNull AABBdc SHAPE_PART_NORTH = new AABBd(0.0, 0.0, 0.0, 1.0, 1.0, PANEL_THICKNESS);
+    private static final @NotNull AABBdc SHAPE_PART_SOUTH = new AABBd(0.0, 0.0, 1.0 - PANEL_THICKNESS, 1.0, 1.0, 1.0);
+    private static final @NotNull AABBdc SHAPE_PART_UP = new AABBd(0.0, 1.0 - PANEL_THICKNESS, 0.0, 1.0, 1.0, 1.0);
+    private static final int SHAPE_WEST = 1;
+    private static final int SHAPE_EAST = 1 << 1;
+    private static final int SHAPE_NORTH = 1 << 2;
+    private static final int SHAPE_SOUTH = 1 << 3;
+    private static final int SHAPE_UP = 1 << 4;
+    private static final int SHAPE_GROUND = 1 << 5;
+    private static final @Nullable BoundingVolume [] SHAPE_VOLUMES = new BoundingVolume[SHAPE_GROUND + 1];
+
+    private static int getShapeMask(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        final TilePos queryPos = new TilePos();
+        if (source.isBlockNormalCube(tilePos.down(queryPos)) || canBurn(source, tilePos.down(queryPos))) {
+            return SHAPE_GROUND;
+        }
+        int mask = 0;
+        if (canBurn(source, tilePos.west(queryPos))) mask |= SHAPE_WEST;
+        if (canBurn(source, tilePos.east(queryPos))) mask |= SHAPE_EAST;
+        if (canBurn(source, tilePos.north(queryPos))) mask |= SHAPE_NORTH;
+        if (canBurn(source, tilePos.south(queryPos))) mask |= SHAPE_SOUTH;
+        if (canBurn(source, tilePos.up(queryPos))) mask |= SHAPE_UP;
+        return mask == 0 ? SHAPE_GROUND : mask;
+    }
+
+    private static @NotNull List<@NotNull AABBdc> getShapeParts(final int mask) {
+        if (mask == SHAPE_GROUND) {
+            return List.of(SHAPE_PART_GROUND);
+        }
+        final List<AABBdc> parts = new ArrayList<>(5);
+        if ((mask & SHAPE_WEST) != 0) parts.add(SHAPE_PART_WEST);
+        if ((mask & SHAPE_EAST) != 0) parts.add(SHAPE_PART_EAST);
+        if ((mask & SHAPE_NORTH) != 0) parts.add(SHAPE_PART_NORTH);
+        if ((mask & SHAPE_SOUTH) != 0) parts.add(SHAPE_PART_SOUTH);
+        if ((mask & SHAPE_UP) != 0) parts.add(SHAPE_PART_UP);
+        return parts;
+    }
+
+    @Override
+    public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        final AABBd bounds = new AABBd();
+        for (final AABBdc part : getShapeParts(getShapeMask(source, tilePos))) {
+            bounds.union(part);
+        }
+        return bounds;
+    }
+
+    @Override
+    public @Nullable BoundingVolume getBoundingVolume(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        final int mask = getShapeMask(world, tilePos);
+        BoundingVolume volume = SHAPE_VOLUMES[mask];
+        if (volume == null) {
+            volume = BoundingVolume.bakeFromBlockSpaceAabbs(getShapeParts(mask).toArray(new AABBdc[0]));
+            SHAPE_VOLUMES[mask] = volume;
+        }
+        return volume;
+    }
+
+    @Override
+    public @Nullable HitResult collisionRayTrace(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Vector3dc start, final @NotNull Vector3dc end, final boolean useSelectionAABB) {
+        @Nullable HitResult closest = null;
+        double closestDistSq = Double.POSITIVE_INFINITY;
+        for (final AABBdc part : getShapeParts(getShapeMask(world, tilePos))) {
+            final @Nullable HitResult hit = traceRayAgainstLocalAABB(tilePos, start, end, part);
+            if (hit != null) {
+                final double distSq = start.distanceSquared(hit.location);
+                if (distSq < closestDistSq) {
+                    closestDistSq = distSq;
+                    closest = hit;
+                }
+            }
+        }
+        return closest;
+    }
+
     @Override
     public boolean isSolidRender() {
         return false;
@@ -230,15 +315,19 @@ public class BlockLogicFire
             // Logs should always scorch when they burn, never convert into a fire block first.
             if (targetBlock.getLogic() instanceof BlockLogicLog) {
                 this.setBurnResult(world, tilePos);
+                this.onBlockBurnt(world, tilePos, random);
                 return;
             }
 
             if (random.nextInt(meta + 10) < 5 && !world.isBlockBeingRainedOn(tilePos)) {
                 if (this.getBurnResult(world, tilePos) == Blocks.AIR /* Fix for fire destroying moss blocks */) {
                     //Spread Fire with higher meta
-                    world.setBlockTypeDataNotify(tilePos, this.getSpreadFireBlock(), Math.min(meta + random.nextInt(5) / 4, 15));}
+                    world.setBlockTypeDataNotify(tilePos, this.getSpreadFireBlock(), Math.min(meta + random.nextInt(5) / 4, 15));
+                    this.onBlockBurnt(world, tilePos, random);
+                }
             } else {
                 this.setBurnResult(world, tilePos);
+                this.onBlockBurnt(world, tilePos, random);
             }
 
             if (isTNT) {
@@ -247,6 +336,51 @@ public class BlockLogicFire
         }
     }
 
+    protected void onBlockBurnt(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
+        for (int i = 0; i < 6; i++) {
+            world.spawnParticle("ashmote", tilePos.x() + rand.nextFloat(), tilePos.y() + rand.nextFloat(), tilePos.z() + rand.nextFloat(), 0.0D, 0.0D, 0.0D, 0, 32.0D, true);
+        }
+        if (rand.nextFloat() < ASH_LAYER_CHANCE) {
+            this.tryPlaceAshLayer(world, tilePos);
+        }
+    }
+
+    private void tryPlaceAshLayer(final @NotNull World world, final @NotNull TilePosc burntPos) {
+        final @NotNull TilePos probe = new TilePos(burntPos);
+        final @NotNull TilePos below = new TilePos();
+        for (int i = 0; i < ASH_GROUND_SCAN_RANGE && probe.y > 0; i++, probe.y--) {
+            final Block<?> blockAtProbe = world.getBlockType(probe);
+
+            if (blockAtProbe == Blocks.LAYER_ASH) {
+                final int height = world.getBlockData(probe) & BlockLogicLayerBase.MASK_HEIGHT;
+                if (height < 6) {
+                    world.setBlockData(probe, height + 1);
+                    world.markBlockNeedsUpdate(probe);
+                } else {
+                    world.setBlockTypeNotify(probe, Blocks.BLOCK_ASH);
+                }
+                return;
+            }
+
+            if (blockAtProbe.getLogic() instanceof BlockLogicFire) {
+                continue;
+            }
+
+            if (isAshGround(world, probe.down(below)) && Blocks.LAYER_ASH.canPlaceAt(world, probe)) {
+                world.setBlockTypeNotify(probe, Blocks.LAYER_ASH);
+                return;
+            }
+
+            if (isAshGround(world, probe) || blockAtProbe.getMaterial().isLiquid()) {
+                return;
+            }
+        }
+    }
+
+    private static boolean isAshGround(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return world.isBlockOpaqueCube(tilePos) || world.getBlockType(tilePos).getLogic() instanceof BlockLogicTransparent;
+    }
+
     protected boolean canNeighborCatchFire(final @NotNull World world, final @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
         if (canBurn(world, tilePos.east(queryPos))) return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index 49e10c5e3..92852658d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -93,7 +93,7 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid implements BlockLogi
             final int meta = (localFlowDecay < MAX_SPREAD)
                 ? localFlowDecay + flowDecayMod
                 : 1;
-            final int spreadDistance = (MAX_SPREAD - localFlowDecay) / flowDecayMod - 1;
+            final int spreadDistance = (MAX_SPREAD - meta) / flowDecayMod;
             if (spreadDistance <= 0) return;
 
             final byte spreadFlags = getSpreadDirections(world, tilePos, spreadDistance);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
index af63cfeea..a2c559481 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
@@ -7,7 +7,6 @@ import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
@@ -37,23 +36,11 @@ public class BlockLogicLayerAsh extends BlockLogicLayerSupportable
         }
     }
 
-    public void accumulate(@NotNull World world, @NotNull TilePosc tilePos) {
-        int myMetadata = world.getBlockData(tilePos);
-        if (myMetadata == 0x7) return;
-
-        for (final var dir : Direction.horizontal) {
-            TilePos dirPos = tilePos.add(dir, new TilePos());
-            if (!((world.isBlockOpaqueCube(dirPos)) || (world.getBlockType(dirPos) == this.block && world.getBlockData(dirPos) >= myMetadata))) return;
-        }
-
-        world.setBlockData(tilePos, myMetadata + 1);
-        world.markBlockNeedsUpdate(tilePos);
-    }
-
     @Override
-    public @NotNull ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return switch (dropCause) {
-            case SILK_TOUCH, PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
+            case SILK_TOUCH -> new ItemStack[]{new ItemStack(this, data + 1)};
+            case PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
             default -> null;
         };
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
index f2d134527..fdcda18e8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
@@ -63,7 +63,7 @@ public abstract class BlockLogicLayerBase extends BlockLogic implements BlockLog
     }
 
     protected @NotNull AABBd getBoundsFromStateMut(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
-        int data = source.getBlockData(tilePos) & MASK_HEIGHT;
+        int data = Math.min(source.getBlockData(tilePos) & MASK_HEIGHT, 6);
         float f = (float)(2 * (1 + data)) / 16F;
         return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
index 4c083affd..a9640185f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
@@ -35,7 +35,7 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerSupportable implements
 
     public void accumulate(@NotNull World world, @NotNull TilePosc tilePos) {
         int myMetadata = world.getBlockData(tilePos);
-        if (myMetadata == 0x7) return;
+        if (myMetadata >= 6) return;
 
         for (final var dir : Direction.horizontal) {
             TilePos p = tilePos.add(dir, new TilePos());
